Chuyển đến nội dung
Diễn đàn CADViet
  • Thông báo

    • Nguyen Hoanh

      CADViet đã hoàn tất nâng cấp   14/09/2017

      Chào các bạn, CADViet đã hoàn tất việc nâng cấp lên phiên bản mới. Tất cả các chức năng đã hoạt động theo kỳ vọng của ban quản trị. Nếu có vấn đề gì cần phản hồi, các bản post ở đây nhé: Trân trọng, Nguyễn Hoành.
Đăng nhập để thực hiện theo  
duy782006

[Hỏi] Cách tạo hàm con với số lượng đối số thay đổi.

Các bài được khuyến nghị

duy782006    1.374

Mình thử viết 1 hàm con như sau:

(defun duy:tao_circle (dt bk / dt bk bd vtr)

(setq bd (getvar "OSMODE"))

(setvar "osmode" 0)

(cond

((= bk nil) (setq bk 20))

)

(command "circle" dt bk)

(setvar "osmode" bd))

 

Ứng dụng

(defun c:vetron ()

(duy:tao_circle (getpoint) "")

)

 

Hoặc

 

(defun c:vetron ()

(duy:tao_circle (getpoint) 50)

)

 

Thì được nhưng mình muốn cải tạo thành

(defun c:vetron ()

(duy:tao_circle (getpoint) )

)

 

Hiện nay sẽ lổi thiếu đối số, mình muốn đối số bán kính này nếu có thì nhập nếu ko có thì khỏi nhập luôn nó sẽ tự nhận giá trị 20 bác nào rành thì chỉ bảo cho phát với. Cám ơn.

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
Tue_NV    3.841

Mình thử viết 1 hàm con như sau:

(defun duy:tao_circle (dt bk / dt bk bd vtr)

(setq bd (getvar "OSMODE"))

(setvar "osmode" 0)

(cond

((= bk nil) (setq bk 20))

)

(command "circle" dt bk)

(setvar "osmode" bd))

 

Ứng dụng

(defun c:vetron ()

(duy:tao_circle (getpoint) "")

)

 

Hoặc

 

(defun c:vetron ()

(duy:tao_circle (getpoint) 50)

)

 

Thì được nhưng mình muốn cải tạo thành

(defun c:vetron ()

(duy:tao_circle (getpoint) )

)

 

Hiện nay sẽ lổi thiếu đối số, mình muốn đối số bán kính này nếu có thì nhập nếu ko có thì khỏi nhập luôn nó sẽ tự nhận giá trị 20 bác nào rành thì chỉ bảo cho phát với. Cám ơn.

Đây anh:


(defun duy:tao_circle (lst-dtbk / dt bk bd vtr)
(mapcar 'set '(dt bk) lst-dtbk)
(setq bd (getvar "OSMODE"))
(setvar "osmode" 0)
(cond
((= bk nil) (setq bk 20))
)
(command "circle" dt bk)
(setvar "osmode" bd))
;;;
(defun c:vetron1 ()
(duy:tao_circle (list (getpoint) ))
)      
(defun c:vetron2 ()
(duy:tao_circle (list (getpoint) 50 ))
)

  • Vote tăng 2

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
duy782006    1.374

Đây anh:


(defun duy:tao_circle (lst-dtbk / dt bk bd vtr)
(mapcar 'set '(dt bk) lst-dtbk)
(setq bd (getvar "OSMODE"))
(setvar "osmode" 0)
(cond
((= bk nil) (setq bk 20))
)
(command "circle" dt bk)
(setvar "osmode" bd))
;;;
(defun c:vetron1 ()
(duy:tao_circle (list (getpoint) ))
)      
(defun c:vetron2 ()
(duy:tao_circle (list (getpoint) 50 ))
)

 

Giải quyết được nhưng lòi thèn list trong lệnh ứng dụng. Có các nào khác nửa không nhỉ tạo thấy lisp co 1 số hàm cho phép nhập số lượng dối số khác nhau theo kiểu (ham a b c) hoặc (ham a B).

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
ketxu    2.649

 

Giải quyết được nhưng lòi thèn list trong lệnh ứng dụng. Có các nào khác nửa không nhỉ tạo thấy lisp co 1 số hàm cho phép nhập số lượng dối số khác nhau theo kiểu (ham a b c) hoặc (ham a B).

Đấy là các hàm được viết bằng ngôn ngữ khác bác ạ ^^

  • Vote tăng 1

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác
Thaistreetz    515

Trước đây em từng có thắc mắc giống hệt bác Duy rồi. và bác GIa Bach trả lời cho em giống hệt bác Tue_NV. Đúng là giới hạn của ngôn ngữ lisp không cho ta định nghĩa 1 hàm con như vậy bằng lisp bác ạ.

  • Vote tăng 1

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

Tạo một tài khoản hoặc đăng nhập để nhận xét

Bạn cần phải là một thành viên để lại một bình luận

Tạo tài khoản

Đăng ký một tài khoản mới trong cộng đồng của chúng tôi. Điều đó dễ mà.

Đăng ký tài khoản mới

Đăng nhập

Bạn có sẵn sàng để tạo một tài khoản ? Đăng nhập tại đây.

Đăng nhập ngay

Đăng nhập để thực hiện theo  

×